module genLRmodule
	use compute
	implicit none

	contains
	
	subroutine setgenLR()
		real	:: val
		integer	:: l,i
		real	:: cvs(napp), l0,lLR
		logical	:: opttest(nsim)
		real	:: lengths(2,nalt)
		
!$omp parallel do
		do l=1,nsim
			genLRstats(l)=getgenLR(Zs(:,l))
		enddo
		do i=1,napp
			cvs(i)=getcv(genLRstats,densapp(i,:),alpha)
		enddo
		print *,"genLR critical values"
		call mdisp(appgrid.cvr.cvs)
		cvgenLR=maxval(cvs)
		
		opttest=matmul(lam,densapp)>densalt
		l0=sum(densalt,mask=opttest)/nsim
		LLR=sum(densalt,mask=genLRstats<cvgenLR)/nsim
		print *,"lenght of genLR CI",lLR,lLR/l0
		rlgenLR=lLR/l0
		
		do i=1,nalt
			lengths(1,i)=sum(densaltraw(i,:),mask=genLRstats<cvgenLR)/nsim
			lengths(2,i)=sum(densaltraw(i,:),mask=opttest)/nsim
		enddo
		print *,"Length as function of xsi"
		call disp(altgrid.cud.lengths)
	end subroutine

		

	function getmu(sig,xsi,q) result(val)
		real	:: sig,xsi,q,val
		val=q-sig*getqxsi(xsi)
	end function
	
	function getrepara1(msx) result(val)
		real	:: msx(3),val(3)
		real	:: mu,sig,xsi
		real	:: t1,t2
		mu=msx(1); sig=msx(2); xsi=msx(3)
		val=[mu,log(sig),xsi]
	end function
	
	function getrepara1i(tx) result(val)
		real	:: tx(3),val(3)
		real	:: mu,sig,xsi
		real	:: t1,t2
		mu=tx(1); sig=exp(tx(2)); xsi=tx(3)
		val=[mu,sig,xsi]
	end function
		
	function getrepara0(sxq) result(val)
		real	:: sxq(3),val(2)
		real	:: sig,xsi,q0
		
		sig=sxq(1); xsi=sxq(2); q0=sxq(3)
		val=[log(sig),xsi]
	end function		

	function getrepara0i(txq) result(val)		
		real	:: txq(3),val(3)
		real	:: mu,sig,xsi,q0
		
		xsi=txq(2); q0=txq(3)
		sig=exp(txq(1))
		mu=getmu(sig,xsi,q0)
		val=[mu,sig,xsi]
	end function
	
	function getq(mu,sig,xsi) result(val)
		real	:: mu,sig,xsi,val
		val=mu+sig*getqxsi(xsi)
	end function
	
	function getgenLR(Z) result(val)
		use bconf_int
		real	:: Z(k+1),q,val
		integer	:: i
		integer,parameter	:: nxsi=6,nmu=7,nsig=20
		real, parameter	:: xsigrid(nxsi)=[-.4,-.2,-.01,.01,.2,.4],siggrid(nsig)=exp([(-3.0+(5.0*i)/(nsig-1),i=0,nsig-1)]),mugrid(nmu)=2*[-2.0,-1.0,-.5,0.0,.5,1.0,2.0]
		integer			:: ixsi,imu,isig
		real			:: ll1s(nmu,nsig,nxsi), ll0s(nsig,nxsi), mu,sig,xsi,msx(3)
		integer			:: maxloc0(2), maxloc1(3)
		real			:: th0(2), th1(3), cllmin, mllmin0,mllmin1, th0guess(2), th1guess(3), th0c(2)
		real			:: lb0(2),ub0(2), lb1(3), ub1(3)
		real, parameter	:: maxlog=6
		
		external	:: ext_minusll0, ext_minusll1

		q=Z(k+1)
		globalz=z(1:k)
		do ixsi=1,nxsi
			xsi=xsigrid(ixsi)
			do isig=1,nsig
				sig=siggrid(isig)
				mu=getmu(sig,xsi,q)
				ll0s(isig,ixsi)=getllz(mu,sig,xsi,globalz)
				do imu=1,nmu
					mu=mugrid(imu)
					ll1s(imu,isig,ixsi)=getllz(mu,sig,xsi,globalz)
				enddo
			enddo
		enddo
		
		globalq=q
		
		maxloc0=maxloc(ll0s)
		th0=getrepara0([siggrid(maxloc0(1)),xsigrid(maxloc0(2)),q])
		th0guess=th0
		lb0=[-maxlog,xsimin]
		ub0=[maxlog,xsimax]
		call bconf(ext_minusll0,0,lb0,ub0,th0,xguess=th0guess,fvalue=mllmin0)

		msx=getrepara0i([th0,q])
		mu=msx(1);sig=msx(2);xsi=msx(3)
		
		maxloc1=maxloc(ll1s)
		th1=getrepara1([mugrid(maxloc1(1)),siggrid(maxloc1(2)),xsigrid(maxloc1(3))])
		th1guess=th1
		lb1=[-20.0,-maxlog,xsimin]
		ub1=[20.0,maxlog,xsimax]
		call bconf(ext_minusll1,0,lb1,ub1,th1,xguess=th1guess,fvalue=mllmin1)
		th1guess=getrepara1([mu,sig,xsi])
		call bconf(ext_minusll1,0,lb1,ub1,th1,xguess=th1guess,fvalue=cllmin)

		mllmin1=min(cllmin,mllmin1)
		val=mllmin0-mllmin1
	end function
	
	function getgenLR_CI(Z) result(val)
		use bconf_int
		use nnlpf_int
		real	:: Z(k),val(2)
		integer	:: i
		integer,parameter	:: nxsi=6,nmu=20,nsig=10
		real, parameter	:: xsigrid(nxsi)=[-.4,-.2,-.01,.01,.2,.4],siggrid(nsig)=exp([(-3.0+(5.0*i)/(nsig-1),i=0,nsig-1)]),mugrid(nmu)=3*[(-1.0+(2.0*i)/(nmu-1),i=0,nmu-1)]
		integer			:: ixsi,imu,isig
		real			:: ll1s(nmu,nsig,nxsi), qs(nmu,nsig,nxsi), mu,sig,xsi
		integer			:: maxloc1(3)
		real			:: th1(3),mllmin1, th1guess(3),msx(3)
		real			:: lb1(3), ub1(3)
		real, parameter	:: maxlog=6,maxmu=20
		
		external	:: ext_minusll1, ext_minq, ext_maxq

		globalz=z(1:k)
		do ixsi=1,nxsi
			xsi=xsigrid(ixsi)
			do isig=1,nsig
				sig=siggrid(isig)
				do imu=1,nmu
					mu=mugrid(imu)
					qs(imu,isig,ixsi)=getq(mu,sig,xsi)
					ll1s(imu,isig,ixsi)=getllz(mu,sig,xsi,globalz)
				enddo
			enddo
		enddo
		
		maxloc1=maxloc(ll1s)
		th1=getrepara1([mugrid(maxloc1(1)),siggrid(maxloc1(2)),xsigrid(maxloc1(3))])
		th1guess=th1
		lb1=[-maxmu,-maxlog,xsimin]
		ub1=[maxmu,maxlog,xsimax]
		call bconf(ext_minusll1,0,lb1,ub1,th1,xguess=th1guess,fvalue=globallf1)
		globallf1=-globallf1
		

		msx=getrepara1i(th1)
		mu=msx(1); sig=msx(2); xsi=msx(3)
		th1guess=[mu,log(sig),xsi]
		call nnlpf(ext_minq,1,0,0,lb1,ub1,th1,xguess=th1guess,fvalue=val(1),idtype=2,maxitn=400,delmin=1E-4)
		if(iercd()>1000) then
			print *,"problem in lower bound determination"
			msx=getrepara1i(th1)
			mu=msx(1); sig=msx(2); xsi=msx(3)
			call mdisp([val,mu,sig,xsi,getq(mu,sig,xsi),getllz(mu,sig,xsi,globalz)-globallf1+cvgenLR])
		endif

		call nnlpf(ext_maxq,1,0,0,lb1,ub1,th1,xguess=th1guess,fvalue=val(2),idtype=2,maxitn=400,delmin=1E-4)
		if(iercd()>1000) then
			print *,"problem in upper bound determination"
			msx=getrepara1i(th1)
			mu=msx(1); sig=msx(2); xsi=msx(3)
			call mdisp([val,mu,sig,xsi,getq(mu,sig,xsi),getllz(mu,sig,xsi,globalz)-globallf1+cvgenLR])
		endif
		val(2)=-val(2)

	end function
	
	
	function getllz(mu,sig,xsi,Z) result(val)
		real	:: mu,sig,xsi,Z(k),val
		
		if(1+xsi*(z(k)-mu)/sig<0 .or. 1+xsi*(z(1)-mu)/sig<0) then
			val=-1E100
		else
			val=-(1+xsi*(z(k)-mu)/sig)**(-1/xsi)-(1+1/xsi)*sum(log1p(xsi*(z-mu)/sig))-k*log(sig)
		endif
	end	function	
end module

subroutine ext_minq(msx,iact,val,ierr)
	use genLRmodule
	implicit none
	real	:: msx(3),val
	integer	:: iact
	logical	:: ierr
	
	real	:: mu,sig,xsi,q,lv
	
	ierr=.false.
	mu=msx(1); sig=exp(msx(2)); xsi=msx(3)
	if(iact==0) then
		val=getq(mu,sig,xsi)
		return
	endif
	lv=getllz(mu,sig,xsi,globalz)
	if(lv<-1E50) ierr=.true.
	val=cvgenLR-globallf1+lv
end subroutine	
	
subroutine ext_maxq(msx,iact,val,ierr)
	use genLRmodule
	implicit none
	real	:: msx(3),val
	integer	:: iact
	logical	:: ierr
	
	real	:: mu,sig,xsi,q,lv
	
	ierr=.false.
	mu=msx(1); sig=exp(msx(2)); xsi=msx(3)
	if(iact==0) then
		val=-getq(mu,sig,xsi)
		return
	endif
	lv=getllz(mu,sig,xsi,globalz)
	if(lv<-1E50) ierr=.true.
	val=cvgenLR-globallf1+lv
end subroutine
	
subroutine ext_minusll1(n,x,val)
	USE, INTRINSIC :: IEEE_ARITHMETIC
	use	genLRmodule
	implicit none
	integer	:: n
	real	:: x(n),val
	real	:: mu,sig,xsi,msx(3)
	
	msx=getrepara1i(x)
	mu=msx(1); sig=msx(2); xsi=msx(3)
	val=-getllz(mu,sig,xsi,globalz)
	if(IEEE_IS_FINITE(val).and.val<1E50) return
	val=1E100
end subroutine
	
subroutine ext_minusll0(n,x,val)
	USE, INTRINSIC :: IEEE_ARITHMETIC
	use	genLRmodule
	implicit none
	integer	:: n
	real	:: x(n),val
	real	:: mu,sig,xsi,msx(3) 
	
	msx=getrepara0i([x,globalq])
	mu=msx(1); sig=msx(2); xsi=msx(3)
	if(xsi==0.0) xsi=0.001
	val=-getllz(mu,sig,xsi,globalz)
	if(IEEE_IS_FINITE(val).and.val<1E50) return
	val=1E100
end subroutine
	
	