function out = jevLR(p,z)
% likelihood of the joint extreme value distribution
% input: 
% 1. p: 1x3 vector, [xsi,sigma,mu]
% 2. z: 1xk vector of z
% output: minus log likelihood (to be minimized)
k = length(z) ;
out = (1+p(1)/p(2)*(z(k)-p(3))).^(-1/p(1))...
       +(1+1/p(1))*sum(log(1+p(1)/p(2)*(z-p(3))),2)...
               +k*log(p(2)) ;