% main script to compute CI, including setting path, clean data and so on
% supplementary code to Mueller and Wang 2018 JASA
clear; clc ;
% step 1: set path to current folder, including all the supporting scripts
% step 2: load data
X = [105.8,27.8,20.6,19.8,15.8,11.8,11,10,9.2,8.1] ; % this is the Earthquake loss data
% step 3: set nominal level, h, and whether quantile or TCE
alpha = 0.05 ;
h = 5 ;
est_tce = 0 ;
% step 4: order the data descendingly and send the largest k observations
% to the computation function
k = 10 ; 
% currently only for k = 5,10,15,20,30,40,50,75,and 100.
X = sort(X,'descend') ;
[LCL_opt,UCL_opt] = compute_CI_opt(X(1:k),h,alpha,est_tce)
% the optimal confidence interval
% occasionally this CI is empty, then the program displays 'CI is empty' and
% produces [-1,-1]

[LCL_glr,UCL_glr] = compute_CI_glr(X(1:k),est_tce,h,alpha)
% the generalized LR confidence interval